-module(worker).
-export([loop/0, rpc/2]).

rpc(Pid,Request) ->
  Pid ! {self(), Request},
  receive
    {Pid,Response} -> Response
  end.
  
loop() ->
  receive
    {From, {work, {Pop,M,DataPoints,DataValues}}} ->
      Results = lists:map(fun(I) ->
        driver:eval_fitness_individual(I,M,DataPoints,DataValues) end, Pop),
      From ! {self(), {Results,Pop}},
      loop();
    {From, Other} ->
      From ! {self(), {error,Other}},
      loop()
  end.